#scvelo transition
############
ls */*scvelo.loom > loom_obj_list

import scvelo as scv
import os, sys
import anndata
import pandas as pd
import matplotlib as mpl
mpl.use('Agg')
import matplotlib.pyplot as plt
import numpy as np

def prob_mat(Adata, name):
                save1 = open(name + "_distribution", "w")
                save2 = open(name + "_transition_mean", "w")
                state2state_dist = {}
                #state2state[potential][initial][prob_list]
                cell_list = np.unique(Adata.obs["clusters"])
                save2.write("potential\\initial")
                head = True
                trans = scv.utils.get_transition_matrix(Adata).toarray()
                trans1 = trans.transpose()
                for cell in cell_list:
                                adata_cell2state = trans1[Adata.obs["clusters"] == cell].sum(axis = 0)
                                if cell not in state2state_dist:
                                                state2state_dist[cell] = {}
                                if head:
                                                head=False
                                                for cell2 in cell_list:
                                                                save2.write("\t" + cell2)
                                                save2.write("\n")
                                save2.write(cell)
                                for cell2 in cell_list:
                                                adata_state2state = adata_cell2state[Adata.obs["clusters"] == cell2]
                                                state2state_dist[cell][cell2] = adata_state2state
                                                mean_val = adata_cell2state[Adata.obs["clusters"] == cell2].mean()
                                                save2.write("\t" + str(mean_val))
                                                save1.write(cell2 + "->" + cell)
                                                for val in adata_state2state:
                                                                save1.write("\t" + str(val))
                                                save1.write("\n")
                                save2.write("\n")
                save1.close()
                save2.close()
                return state2state_dist




data_list = list(line.strip() for line in open('loom_obj_list'))

for line in data_list:
 data = anndata.read_loom(line)
 scv.tl.velocity_graph(data, basis = "umap")
 cell_tmp = line.split("/")
 cell_tmp1 = cell_tmp[1].split("_scvelo")
 cell_name = cell_tmp1[0]
 dummy = prob_mat(data, cell_name)

