#!/usr/bin/python3
#Author: Jae-Won,Cho
#Update: 20220519(Thur)
#usage: cellchat_rl_parse.py [gnlist]



import sys,os


data = open(sys.argv[1], 'r')
save = open(sys.argv[1] + "_parse", 'w')


filter_list = set(["COL6A1", "COL6A2", "COL6A3", "COL9A2"])
parse_dict = {"ITGAM_ITGB2": ["ITGAM", "ITGB2"], "ITGAX_ITGB2": ["ITGAX", "ITGB2"], "ITGAL_ITGB2": ["ITGAL", "ITGB2"], "ITGB1_ITGA1": ["ITGB1", "ITGA1"], "CD94:NKG2A": ["KLRD1", "KLRC1"], "CD94:NKG2C": ["KLRD1", "KLRC2"],"CD94:NKG2E": ["KLRD1", "KLRC3"]}


total_gn = set()
for line in data:
	gn = line.strip()
	if gn in filter_list:
		continue
	if gn in parse_dict:
		total_gn.add(parse_dict[gn][0])
		total_gn.add(parse_dict[gn][1])
	else:
		total_gn.add(gn)
data.close()

for b in total_gn:
	save.write(b + "\n")
save.close()
  

