#!/usr/bin/python

#Program: deg_threshold.py
#Author: Jae-Won,Cho
#Date: 20190602(Sun)
#Description: thresholding deg

#Usage:./deg_threshold.py [deg file list][input_directory][qval threshold][logfc threshold][cell raito threshold: t or anything else)
#input directory: ~/egfr_lung/analysis/integrated/celltype_deg
#qval < 0.05, |logfc| > 0.25
#cell ratio threshold: t -> cell1  > cell2
import sys,os, math
import operator

data = open(sys.argv[1], 'r')
pre_dir = sys.argv[2]
qval_thr = float(sys.argv[3])
logfc_thr = float(sys.argv[4])
cell_thr = sys.argv[5]

for line in data:
	f_name = line.strip()
	f_name = pre_dir + f_name
	save = open(f_name + "_thr", 'w')
	tmp_f = open(f_name, 'r')

	head = True
	for fline in tmp_f:
		fline = fline.strip()
		if head:
			head = False
			continue

		fline_list = fline.split("\t")
		gn = fline_list[0]
		qval = float(fline_list[5])
		logfc = float(fline_list[2])
		pct_w = float(fline_list[3])
		pct_m = float(fline_list[4])
		if qval >= qval_thr:
			continue
		if cell_thr == "t":
			if logfc > logfc_thr and pct_w > pct_m:
				save.write("%s\n" % fline)
		
			elif logfc < -1*logfc_thr and pct_w < pct_m: 
				save.write("%s\n" % fline)

		else:
			if logfc > logfc_thr:
				save.write("%s\n" % fline)
			elif logfc < -1*logfc_thr:
				save.write("%s\n" % fline)
	tmp_f.close()
	save.close()
data.close()

