#!/usr/bin/python

#Program: tcr.py
#Author: Jae-Won,Cho
#Date: 20200318(Wed)
#Description: mapping cell index in the clonotype 
#Usage: ./tcr.py [clontype][filtered_contig]

import sys, getopt

data = open(sys.argv[1], 'r')
contig = open(sys.argv[2], 'r')
save = open(sys.argv[1] + "_map", 'w')

head = True

data_dict = {}

bar_set = set()
for line in contig:
	line = line.strip()
	if head:
		head = False
		continue

	line_list = line.split(",")
	barcode = line_list[0]
	clono = line_list[-2]
	productive = line_list[11]

	
	if productive != "True":
		continue

	if barcode in bar_set:
		if clono in data_dict:
			continue
		else:
			data_dict[clono] = []
	else:
		if clono not in data_dict:
			data_dict[clono] = []
		bar_set.add(barcode)
	data_dict[clono].append(barcode)
contig.close()


save.write("cell\tclonotype_id\tcdr3_aa\tcdr3_nt\n")


head = True
for line in data:
	line = line.strip()
	if head:
		head = False
		continue

	line_list = line.split(",")
	clono = line_list[0]
	aa = line_list[3]
	nt = line_list[4]

	for cell in data_dict[clono]:
		save.write(cell + "\t" + clono + "\t" + aa + "\t" + nt +  "\n")
data.close()
save.close()


