#!/usr/bin/python3.6

#Program: transition_prob.py
#Author: Jae-Won,Cho
#Date: 20200123(Thur)
#Description: transition prob 
#Run from adata variable (see adata_velocity_cd8_mut.py)

#rna_velocity
import numpy as np
import sys, operator
from scipy.stats import mannwhitneyu

wt_trans = scv.utils.get_transition_matrix(wt_data).toarray()
wt_trans1 = wt_trans.transpose()
wt_cell2cd8_0 = wt_trans1[wt_adata.obs["celltype"] == "CD8_0"].sum(axis=0)
#cell-to-CD8_0-state transition per cell

wt_cd8_0tocd8_0 = wt_cell2cd8_0[wt_adata.obs["celltype"] == "CD8_0"]
#CD8_0 cells to CD8_0-state transition distribution

wt_cd8_0tocd8_0 = wt_cell2cd8_0[wt_adata.obs["celltype"] == "CD8_0"].mean()


cell_list = np.unique(adata_wt.ca["celltype"])



def prob_mat(Adata, name):
	save1 = open(name + "_distribution", "w")
	save2 = open(name + "_transition_mean", "w")
	state2state_dist = {}
	#state2state[potential][initial][prob_list]
	cell_list = np.unique(Adata.obs["celltype"])
	save2.write("potential\\initial")
	head = True
	trans = scv.utils.get_transition_matrix(Adata).toarray()
	trans1 = trans.transpose()
	for cell in cell_list:
		adata_cell2state = trans1[Adata.obs["celltype"] == cell].sum(axis = 0)
		if cell not in state2state_dist:
			state2state_dist[cell] = {}	
		if head:
			head=False
			for cell2 in cell_list:
				save2.write("\t" + cell2)
			save2.write("\n")
		save2.write(cell)
		for cell2 in cell_list:
			adata_state2state = adata_cell2state[Adata.obs["celltype"] == cell2]
			state2state_dist[cell][cell2] = adata_state2state
			mean_val = adata_cell2state[Adata.obs["celltype"] == cell2].mean()
			save2.write("\t" + str(mean_val))
			save1.write(cell2 + "->" + cell)
			for val in adata_state2state:
				save1.write("\t" + str(val))
			save1.write("\n")
		save2.write("\n")
	save1.close()
	save2.close()
	return state2state_dist


def wil_state(state2state1, state2state2, name):
	save = open(name, "w")
	for pot in state2state1:
		for init in state2state1[pot]:
			save.write(init + "->" + pot)
			u,p= mannwhitneyu(state2state1[pot][init], state2state2[pot][init], alternative = "two-sided")
			save.write("\t" + str(p) + "\n")
	save.close()

adata_wt_dict = prob_mat(wt_adata, "cd8_wt")
adata_mt_dict = prob_mat(mt_adata, "cd8_mt")

wil_state(adata_wt_dict, adata_mt_dict, "cd8_state_transition_wilcox")

